ElgohSettings_Default={
	["EPGPValues"]=1,
	["EPGPThreshhold"]=750,
	["Debug"]=0,
	["OSDiscount"]=0.5,
	["MiniLvl"]=359,
	["BreaktimeString"]="Breaktime! Be back in TIME minutes!",
	["MSString"]="Roll for ITEM Mainspec",
	["OSString"]="Roll for ITEM Offspec",
	["StartBonus"]=50,
};

ElgohHistory={};
EDB={};
InterestedRaiders={};
ElgohLooters={};
ElgohPromote={};
ElgohRolling=0;
ElgohCurrentItem="";

local frame = CreateFrame("Frame")

local Roles={"TANK","HEALER","DAMAGER"};
function Elgoh_AutoRaid()
	if(IsRaidOfficer() or IsRaidLeader()) then
		for i=1, GetNumRaidMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_,_, isML = GetRaidRosterInfo(i); -- 2=RL, 1=Assist, 0=raider
			guildName, guildRankName, guildRankIndex = GetGuildInfo(name);
			role = UnitGroupRolesAssigned("Raid"..i);
			if(role=="NONE") then
				EDB_Snapshot(name);
				UnitSetRole(name, Roles[EDB[name]["MS"]]);
			end
			if(IsRaidLeader()) then
			if(ElgohPromote[guildRankName]==1 and rank==0) then PromoteToAssistant(name); end
	end
		end
		if(GetLootMethod()~="master") then
			SetLootMethod("master", UnitName("PLAYER"));
		end
	else
		Elgoh_Print("You are not the raid leader (or not in a raid)");
	end
end

local upgrade_warned = false;
function Elgoh_OnEvent(self,event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;		
		if(prefix=="anoo") then
			if(msg=="version") then
				SendAddonMessage("anoo", ElgohVers, "WHISPER", who);	
			else
				EDebug(who.." has "..msg);
				if(tonumber(msg)>(tonumber(ElgohVers)) and not upgrade_warned) then 
					Elgoh_Print("There may be an updated version available from:\nhttp://wow.curse.com/downloads/wow-addons/details/elgoh.aspx"); 
					upgrade_warned=true; 
				end
			end
		elseif(prefix=="elgoh") then
			if(CanEditOfficerNote()==1 and msg:find("^!")~=nil) then
				EDebug("Being Queried for "..string.sub(msg,2).."...");
				for i = 1, GetNumGuildMembers(), 1 do
					local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
					if(name==string.sub(msg,2)) then
						local EDBString=string.match(officernote, "$(.*)%$");
						SendAddonMessage("elgoh", "$"..name.."$"..EDBString, "WHISPER", who);
						EDebug("Sending $"..name.."$"..EDBString);
					end
				end
			elseif(CanEditOfficerNote()~=1 and string.find(msg,"^%$")~=nil) then
				EDebug("Officer Reply...");
				ElgohWaitingOnOfficer=false;
				who=msg:match("^$(.*)%$");
				msg=string.sub(msg,who:len()+3);
				EDebug(msg);
				local MS,OS,Earned,Spent,Priority=strsplit(":",msg);
				MS=tonumber(MS);
				OS=tonumber(OS);
				Earned=tonumber(Earned);
				Spent=tonumber(Spent);
				Priority=tonumber(Priority);
				
				EDB[who]={};
				EDB[who]["MS"]=MS;
				EDB[who]["OS"]=OS;
				EDB[who]["earned"]=Earned;
				EDB[who]["spent"]=Spent;
				EDB[who]["priority"]=Priority;
				EDB_UpdateLines(EDB.selected);
			end
		end
	elseif(event=="CHAT_MSG_SYSTEM") then
		local message=...; if(message:find("rolls %d+"))==nil then return; end
		local name=strmatch(message, "^(%a+) ");
		--EDebug(name.." rolled!");
		Elgoh_RaiderInterested(name);
	elseif(event=="CHAT_MSG_RAID_WARNING") then
		if(ElgohRolling==1) then return; end
		for i=1, GetNumRaidMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i);
			if(name==UnitName("PLAYER") and (isML or ElgohSettings.Debug==1)) then
				local message,who=...; if(message:find("|h%["))==nil then EDebug("No itemLink"); return; end
				local item=string.match(message, "(%[.+%])");
				EDebug("Item: "..item);
				LootingReset();
				ElgohRolling=1;
				ElgohCurrentItem=message:match("(|cff.+|r)");
				Elgoh_RefreshLootList();
				return;
			end
		end
	elseif(event=="CHAT_MSG_WHISPER") then
		local message,who=...; if(message:find("^!dkp")==nil and message:find("^!dpl")==nil) then return; end
		if(message:find("^!dpl")) then SendChatMessage("I just did "..math.random(9001).." dpl!", "WHISPER", nil, who); return; end
		Elgoh_DKPWhisper(who);
	elseif(event=="LOOT_OPENED" or event=="LOOT_SLOT_CLEARED" or event=="LOOT_SLOT_CHANGED" or event=="LOOT_CLOSED") then
		if(ElgohSettings.Debug==1) then Elgoh_LootShow(); end
		if(GetLootMethod()~="master" or GetNumRaidMembers()==0) then return; end
		for i=1, GetNumRaidMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i);
			if(name==UnitName("PLAYER") and isML) then
				Elgoh_LootShow();
			end
		end
	end
end

function Elgoh_Rottgut()
	local kick=0;
	for i = 1, GetNumGuildMembers(), 1 do 
		local _, monthsOffline, daysOffline = GetGuildRosterLastOnline(i);
		local name,_,_, level,_,_, note,_, online = GetGuildRosterInfo(i);
		if(online~=1 and (daysOffline>20 and level<=40) or daysOffline>=29 or monthsOffline>0) then 
			Elgoh_Print("Kicking "..name.." ("..rank..")"..note)
			if Remove then GuildUninvite(name); end
			kick=kick+1;
		end
	end
	if(kick==0) then Elgoh_Print("No inactive players"); return; end
	if Remove then Remove=false; else Remove=true; Elgoh_Print(kick.." people will be removed"); end
end

local ElgohLoaded=false;
function Elgoh_Loaded(self, event, addon)
	if (event == "ADDON_LOADED" and addon:lower()=="elgoh") then
		ElgohLoaded=true;
	elseif(event=="PLAYER_LOGIN" and ElgohLoaded==true) then
		frame:SetScript("OnEvent", Elgoh_OnEvent);
		frame:RegisterEvent("CHAT_MSG_ADDON");
		frame:RegisterEvent("CHAT_MSG_WHISPER");
		frame:RegisterEvent("LOOT_OPENED");
		frame:RegisterEvent("LOOT_SLOT_CLEARED");
		frame:RegisterEvent("LOOT_SLOT_CHANGED");
		frame:RegisterEvent("LOOT_CLOSED");
		frame:RegisterEvent("CHAT_MSG_RAID_WARNING");
		frame:RegisterEvent("CHAT_MSG_SYSTEM");
		
		RegisterAddonMessagePrefix("elgoh");
		RegisterAddonMessagePrefix("anoo");
		
		Elgoh_HookTooltips();
		Elgoh_AddDropdowns();
		
		LootFrameDownButton:HookScript("OnClick", Elgoh_LootShow);
		LootFrameUpButton:HookScript("OnClick", Elgoh_LootShow);
		
		if(ElgohSettings==nil) then Elgoh_Print("No settings found, defaulting..."); ElgohSettings=ElgohSettings_Default; end
		if(ElgohSettings["StartBonus"]==nil) then Elgoh_Print("No settings found, defaulting..."); ElgohSettings=ElgohSettings_Default; end
		
		if(ElgohSettings.Debug==1) then InterfaceOptionsFrame_OpenToCategory("Elgoh"); end
		
		ElgohVers=GetAddOnMetadata("Elgoh", "X-Curse-Packaged-Version")
		if(ElgohVers==nil) then ElgohVers="r1"; end --it's NIL if using the working copy
		ElgohVers = string.sub(ElgohVers, 2); --gets rid of the r
		
		SendAddonMessage("anoo", ElgohVers, "GUILD"); --Addon update check for if they have an older copy
		SendAddonMessage("anoo", "version", "GUILD"); --Addon update check for if YOU have an older copy
		
		Elgoh_Print("Version "..ElgohVers.." has been loaded");
		Cauld_Loaded();
	end
	if(event=="ADDON_LOADED" and addon:lower()=="itemleveldkp") then
		Elgoh_Print("Detected Addon: ItemLevelDKP and ELGoH serve the same purpose and may cause each other to stop working");
	end
end

function EditLoot()
	LootFrame:SetWidth(500);
	LootFrame:SetBackdrop(nil);
	LootFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
												tile = true, tileSize = 16, edgeSize = 16, 
												insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	LootFrame:SetBackdropColor(0,0,0,1);
end

frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("PLAYER_LOGIN");
frame:SetScript("OnEvent", Elgoh_Loaded);